---------------------------------------------------------------------------
--                                                                       --
--  Ast2Cfg is an ASIS application that generates a CFG out of the AST.  --
--                          http://cfg.w3x.org                           --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
--     Copyright (c) 2007, 2008, 2009 Raul Fechete, Georg Kienesberger   --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
-- This file is part of Ast2Cfg.                                         --
--                                                                       --
-- Ast2Cfg is free software; you can redistribute it and/or modify       --
-- it under the terms of the GNU General Public License as published by  --
-- the Free Software Foundation; either version 3 of the License, or     --
-- (at your option) any later version.                                   --
--                                                                       --
-- Ast2Cfg is distributed in the hope that it will be useful,            --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of        --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         --
-- GNU General Public License for more details.                          --
--                                                                       --
-- You should have received a copy of the GNU General Public License     --
-- along with this program.  If not, see <http://www.gnu.org/licenses/>. --
--                                                                       --
---------------------------------------------------------------------------

with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with Ast2Cfg.Pkgs; use Ast2Cfg.Pkgs;

package Ast2Cfg.Flow_World is

   type World_Object is tagged limited private;
   type World_Object_Ptr is access all World_Object;

   procedure Init     (World: in out World_Object);

   procedure Free     (World: in out World_Object_Ptr);

   procedure Add_Pkg  (World: in out World_Object; Pkg: in Pkgs.Pkg_Class_Ptr);
   function  Get_Pkgs (World: in World_Object) return Pkgs.Pkg_Class_Ptr_List.Object;

private

   type World_Object is tagged limited
      record
         Pkg_List: Pkgs.Pkg_Class_Ptr_List.Object;
      end record;

end Ast2Cfg.Flow_World;
