---------------------------------------------------------------------------
--                                                                       --
--  Ast2Cfg is an ASIS application that generates a CFG out of the AST.  --
--                          http://cfg.w3x.org                           --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
--     Copyright (c) 2007, 2008, 2009 Raul Fechete, Georg Kienesberger   --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
-- This file is part of Ast2Cfg.                                         --
--                                                                       --
-- Ast2Cfg is free software; you can redistribute it and/or modify       --
-- it under the terms of the GNU General Public License as published by  --
-- the Free Software Foundation; either version 3 of the License, or     --
-- (at your option) any later version.                                   --
--                                                                       --
-- Ast2Cfg is distributed in the hope that it will be useful,            --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of        --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         --
-- GNU General Public License for more details.                          --
--                                                                       --
-- You should have received a copy of the GNU General Public License     --
-- along with this program.  If not, see <http://www.gnu.org/licenses/>. --
--                                                                       --
---------------------------------------------------------------------------

package body Ast2Cfg.Pkgs is

   overriding
   procedure Init (Pkg:  in out Pkg_Object;
                   Oid:  in Id.Pointer;
                   Name: in Unbounded_String;
                   Pred: in Flow_Class_Ptr;
                   Element: in Asis.Element) is
   begin
      Flow_Types.Init(Flow_Object(Pkg), Oid, Name, Pred, Element);
      Declaration_Id.Init(Pkg.Decl_Id);
   end;

   not overriding
   procedure Free (Pkg: in out Pkg_Class_Ptr) is
   begin
      if Pkg /= null then
         Flow_Types.Free(Flow_Class_Ptr(Pkg));
      end if;
   end Free;

   not overriding
   procedure Free_Special (Pkg: in out Pkg_Class_Ptr) is
   begin
      null;
   end Free_Special;

   not overriding
   procedure Init (Pkg:  in out Pkg_Object;
                   Name: in Unbounded_String;
                   Pred: in Flow_Class_Ptr;
                   Element: in Asis.Element) is
   begin
      Init(Pkg, Id.New_Pkg_Id, Name, Pred, Element);
   end Init;

   not overriding
   function Get_Declaration_Id (Pkg: in Pkg_Object) return Declaration_Id.Object is
   begin
      return Pkg.Decl_Id;
   end Get_Declaration_Id;

end Ast2Cfg.Pkgs;
